.TH swodec 1 "Mar 12, 2017"
.SH NAME
swodec \- decode SWO trace data

.SH SYNOPSIS
.B swodec [OPTIONS]

.SH DESCRIPTION
.B swodec
is a command-line utility to decode SWO trace data.

.SH OPTIONS
.TP
.B \-h, \-\-help
Show a help text and exit.

.TP
.B \-V, \-\-version
Show version information and exit.

.TP
.B \-l, \-\-log\-level
Set the log level of \fBswodec\fP and \fBlibswo\fP. The following log levels
are available:

.RS
.RS
.TP
.B none (0)
No messages
.TP
.B error (1)
Error messages
.TP
.B warn (2)
Warning messages
.TP
.B info (3)
Informational messages
.TP
.B debug (4)
Debug messages
.RE

The name or its correspoding number can be used to specify a log level.
.RE

.TP
.BR "\-i, \-\-input\-file " <filename>
Load trace data from a file instead of using standard input.

.TP
.BR "\-f, \-\-filter " <list>
A comma-separated list of packet types to filter for. The following packet types
are available:

.RS
.RS
.TP
.B sync
Synchronization
.TP
.B of
Overflow
.TP
.B lts
Local timestamp
.TP
.B gts
Global timestamp. This is a shortcut for \fBgts1\fP and \fBgts2\fP.
.TP
.B gts1
Global timestamp (GTS1)
.TP
.B gts2
Global timestamp (GTS2)
.TP
.B ext
Extension
.TP
.B inst
Instrumentation
.TP
.B hw
Hardware source. This is for hardware source packets which could not be decoded
as Data Watchpoint and Trace (DWT) packets.
.TP
.B dwt
Data Watchpoint and Trace (DWT). This is a shortcut for \fBevtcnt\fP,
\fBexctrc\fP, \fBpcsample\fP, \fBpcvalue\fP, \fBaddroffset\fP and
\fBdatavalue\fP.
.TP
.B evtcnt
Event counter
.TP
.B exctrc
Exception trace
.TP
.B pcsample
Periodic PC sample
.TP
.B pcvalue
Data trace PC value
.TP
.B addroffset
Data trace address offset
.TP
.B datavalue
Data trace data value
.TP
.B unknown
Unknown data
.RE
.RE

.RS
If a tilde (~) precedes the list the machting sense is inverted.
.RE

.TP
.BR "\-\-filter-inst " <list>
A comma-separated list of instrumentation source addresses to filter for. If a
tilde (~) precedes the list the machting sense is inverted. Each address must be
in the range from \fB0\fP to \fB31\fP.

.TP
.B \-\-dump-inst
Dump the payload of instrumentation packets. All other packet types are filtered
out.

.SH EXAMPLES

In order to decode trace data from a file (e.g. trace.bin), run the following
command:

.RB " $ " "swodec \-\-input\-file trace.bin"

If you want to filter for instrumentation and hardware source packets only, use:

.RB " $ " "swodec \-\-input-file trace.bin \-\-filter inst,hw"

If you are interested in all packets except for unknown data and
synchronization, the simplest way is to invert the sense of matching:

.RB " $ " "swodec \-\-input-file trace.bin \-\-filter ~unknown,sync"
